/*
 * Linux-specific abstractions to gain some independence from linux
 * kernel versions.  Pave over some 2.2 versus 2.4 kernel differences.
 *
 * Copyright (C) 2004 Broadcom Corporation
 * Copyright (C) 2007 Wind River Systems ( Removed old Linux version code)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef _linuxver_h_
#define _linuxver_h_

#include <linux/config.h>
#include <linux/version.h>

#if defined(MODULE) && defined(MODVERSIONS)
#include <linux/modversions.h>
#endif

#include <linux/slab.h>

#include <linux/types.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/mm.h>
#include <linux/string.h>
#include <linux/pci.h>
#include <linux/interrupt.h>
#include <linux/netdevice.h>
#include <asm/io.h>

#ifndef __exit
#define __exit
#endif
#ifndef __devexit
#define __devexit
#endif
#ifndef __devinit
#define __devinit	__init
#endif
#ifndef __devinitdata
#define __devinitdata
#endif

#define netif_down(dev)

#endif				/* _linuxver_h_ */
